# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b54"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/8/cells/4")
sage.server.notebook.interact.SAGE_CELL_ID=4
# Same as above, but use an exponential moving average

price_series = finance.Stock('goog').close()

def strategy(price_series, start, stop, alpha):
    investment = Integer(1)
    average_series = price_series.exponential_moving_average(alpha)
    print '%-6s%-8s%-8s%-4s%-8s%8s'%('day','price','avg','sig','return', '% change')
    for k in range(start, stop-Integer(1)):
         # day k -- moving average up to and including today.
         average = average_series[k]
         if price_series[k] >= average:
             signal = +Integer(1)
         else:
             signal = -Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         print '%-6s%-8.2f%-8.2f%2s  %-3.2f%8.2f'%(k, price_series[k],
                   average, signal, investment, percent_change)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))

exec compile(ur'strategy(price_series, len(price_series)-Integer(100), len(price_series), RealNumber(\u00270.4\u0027))' + '\n', '', 'single')

print "e54"
