# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b38"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/8/cells/5")
sage.server.notebook.interact.SAGE_CELL_ID=5
# Page 82 of Mandelbrot

price_series = finance.Stock('aapl').close()

def strategy(price_series, start, stop, n):
    investment = Integer(1)
    average_series = price_series.simple_moving_average(n)
    print '%-6s%-8s%-8s%-4s%-8s%8s'%('day','price','avg','sig','$', '% change')
    for k in range(start, stop-Integer(1)):
         average = average_series[k]
         if price_series[k] >= average:
             signal = +Integer(1)
         else:
             signal = -Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
         print '%-6s%-8.2f%-8.2f%2s  %-8.2f%-8.2f'%(k, price_series[k],
                   average, signal, investment, percent_change)

exec compile(ur'strategy(price_series, len(price_series)-Integer(100), len(price_series), Integer(20))' + '\n', '', 'single')

print "e38"
