# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b64"
os.chdir("/home/simuw/simuw08/nb/sage_notebook/worksheets/wstein/8/cells/2")
sage.server.notebook.interact.SAGE_CELL_ID=2
# Same as first, but use an exponential moving average with signal reversed

price_series = finance.Stock('goog').close()

def strategy(price_series, start, stop, alpha):
    investment = Integer(1)
    average_series = price_series.exponential_moving_average(alpha)
    for k in range(start, stop-Integer(1)):
         # day k -- moving average up to and including today.
         average = average_series[k]
         if price_series[k] >= average:
             signal = -Integer(1)
         else:
             signal = +Integer(1)
         percent_change = price_series[k+Integer(1)]/price_series[k] - Integer(1)
         if signal == Integer(1):  # buy
             investment = investment * (percent_change + Integer(1))
         else: # short
             investment = investment * (Integer(1)/(percent_change + Integer(1)))
    return investment

def f(alpha):
    return strategy(price_series, len(price_series)-Integer(100), len(price_series), alpha)

exec compile(ur'show(line([(alpha, f(alpha)) for alpha in (ellipsis_range(RealNumber(\u00270.05\u0027),RealNumber(\u00270.1\u0027),Ellipsis,RealNumber(\u00270.95\u0027)))]), xmin=Integer(0),ymin=Integer(0))' + '\n', '', 'single')

print "e64"
